package tp.reseaux;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.util.regex.Pattern;

import javax.swing.AbstractAction;
import javax.swing.JOptionPane;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;

public class ActionBoutonValider extends AbstractAction {
	
	private FenetrePrincipale fenetre;
	private String actionChoisit;
	private PolynomeGenerateur generateurChosit;
	private String chaineBinaire;

	
	public ActionBoutonValider(FenetrePrincipale laFenetre) {
		
		super("Valider");
		putValue(MNEMONIC_KEY, KeyEvent.VK_V);
		putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke("ctrl v"));
		fenetre = laFenetre;
		
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		
		String regexChaineBinaire = "^[01]+$";
		
		actionChoisit = (String) fenetre.comboChoixAction.getSelectedItem();
		generateurChosit = ((PolynomeGenerateur) fenetre.comboChoixGenerateur.getSelectedItem());
		chaineBinaire = fenetre.champsSaisieMots.getText();
		
		if(chaineBinaire.isEmpty()) {
			 JOptionPane.showMessageDialog(fenetre, 
                    "Veuillez saisir une chaine binaire.", 
                    "Erreur", 
                    JOptionPane.ERROR_MESSAGE);
		}
		
		
		if(!Pattern.matches(regexChaineBinaire, chaineBinaire)) {
			 JOptionPane.showMessageDialog(fenetre, 
                   "Veuillez saisir une chaine binaire valide.", 
                   "Erreur", 
                   JOptionPane.ERROR_MESSAGE);
		}
		
		if(actionChoisit == fenetre.choixBoutonActionParDefaut) {
			 JOptionPane.showMessageDialog(fenetre, 
                    "Veuillez choisir une action valide.", 
                    "Erreur", 
                    JOptionPane.ERROR_MESSAGE);
		}
		
		
		if(actionChoisit == fenetre.choixBoutonActionCalculCRC) {
			fenetre.calculerCRC(chaineBinaire, generateurChosit);
		}else if(actionChoisit == fenetre.choixBoutonActionVerificationErreur){
			fenetre.verifierErreur(chaineBinaire, generateurChosit);
		}
		
		
		
	}

}
